' Prozedur ChgFSize     - Dateigre ndern
' Mit der Prozedur kann die Gre einer Datei gendert werden.

' In dieser Prozedur werden nur Dateigren bis maximal 2.147.483.647 (= 2^31 - 1)
' Bytes verarbeitet!!! Der Versuch einen greren Wert zu setzen wird unterdrckt, weil
' eine LongInt Variable dafr 0 setzen wrde.

' Eine Beschreibung und zwei Testprogramme befinden sich in ChgFSize.PRF

' Version 1.0  18.03.2004.     Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka   
'                    homepage: http://www.gerhard-putschalka.xprofan.com/index.htm
'                      email:   gerhard-putschalka@gmx.at

' =====================================================
DEF CreateFile(7)      ! "Kernel32","CreateFileA"
DEF SetFPointer(4)     ! "Kernel32","SetFilePointer"
DEF SetEndFile(1)      ! "Kernel32","SetEndOfFile"
DEF CloseHandle(1)     ! "Kernel32","CloseHandle"
Declare QChName#
Proc Dateiende_setzen
   Parameters FileNam$,NewSize&
   ' Parameter 1 = Pfad\Dateiname, Parameter 2 = neue Dateigre in Bytes (wenn positiv),
   ' wenn negativ, wird die Dateigre um diesen Wert verringert.
   Declare Handle&
   Dim QChName#,128
   String QChName#,0 = FileNam$
   If (NewSize& = 0)
      @Messagebox("Die neue Dateigre wre Null. Es wird abgebrochen.","",64)
   Else
      Handle&= CreateFile(QChName#,$40000000,3,0,$03,$80,0)   ' ffne Datei (zum Schreiben)
      If (Handle& < 0)   ' wenn -1 dann war Fehler
         @Messagebox("Die Datei wurde nicht gefunden. Es wird abgebrochen.",FileNam$,64)
      Else
         ' ist NewSize& negativ wird das Dateiende um den Wert verringert
         ' ist NewSize& positiv ist der Wert die neue Dateigre
         If (NewSize& < 0)
            ' setze den Filepointer. Dateiende - NewSize& = neues Dateiende
            @SetFPointer(Handle&,NewSize&,0,2) ' setze Pointer ans Dateiende - NewSize&
         Else
            ' setze den Filepointer. NewSize& = neue Dateigre
            @SetFPointer(Handle&,NewSize&,0,0)
         EndIf
         ' so wie der Filepointer gesetzt wurde, wird das neue Dateiende gesetzt.
         @SetEndFile(Handle&)
         @CloseHandle(Handle&)
      EndIf
   EndIf
   Dispose QChName#
   Return
EndProc
